package com.maroontress.testfunnel.auditor;

import java.awt.Frame;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.Collection;
import java.util.HashMap;
import javax.swing.JFrame;

/**
   ƥȤΥץѥƥΥեȥ꡼
*/
public final class PropertyFactory {

    /** 饹̾ȥץѥƥΥϥåޥå */
    private HashMap<String, JFrame> frameMap;

    /**
       ץѥƥΥեȥ꡼ޤ

       @param parent ץѥƥοƥե졼
    */
    public PropertyFactory(final JFrame parent) {
	frameMap = new HashMap<String, JFrame>();
	parent.addWindowListener(new WindowAdapter()  {
	    public void windowClosed(final WindowEvent ev) {
		closeAll();
	    }
	});
    }

    /**
       ץѥƥ򳫤ޤ

       @param className ƥȤΥ饹̾
       @param desc ƥȤ
    */
    public void open(final String className, final String desc) {
	synchronized (frameMap) {
	    JFrame frame;

	    if ((frame = frameMap.get(className)) != null) {
		frame.setExtendedState(Frame.NORMAL);
		frame.toFront();
		return;
	    }
	    frame = new Property(className, desc, new DialogAction() {
		public void close() {
		    synchronized (frameMap) {
			JFrame frame;

			if ((frame = frameMap.get(className)) == null) {
			    return;
			}
			frame.dispose();
			frameMap.remove(className);
		    }
		}
	    });
	    frameMap.put(className, frame);
	    frame.setVisible(true);
	}
    }

    /**
       ե졼˽°ץѥƥ򤹤٤Ĥޤ
    */
    public void closeAll() {
	synchronized (frameMap) {
	    Collection<JFrame> allFrames = frameMap.values();
	    for (JFrame frame : allFrames) {
		frame.dispose();
	    }
	    frameMap.clear();
	}
    }
}
