package com.maroontress.testfunnel.auditor;

import java.awt.GridLayout;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.awt.event.ComponentEvent;
import java.awt.event.ComponentListener;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JProgressBar;

/**
   Хå饦ɤǼ¹Ԥʤ顢μ¹Ծ֡ʿĽˤץ쥼
   ơ󤹤쥯饹
*/
public abstract class Servant {

    /** ĽΥѡȤκ */
    public static final int PROGRESS_MAX = 100;

    /** ץ쥹С */
    private JProgressBar progress;

    /**  */
    private JDialog dialog;

    /** ߤɤ */
    private boolean stopped;

    /** ׵륹å */
    private Thread thread;

    /** åɤ¹Ԥ륪֥ */
    private Runnable task;

    /** ƥե졼 */
    private JFrame parent;

    /** ߡλΤ륪֥ */
    private Runnable listener;

    /**
       ХȤޤ

       @param parent 쥷ԤΥɽֿĽפο
       Ȥʤե졼
       @param buttonLabel Υܥʸ
    */
    protected Servant(final JFrame parent,
		      final String buttonLabel) {
	this.parent = parent;
	thread = null;

	progress = new JProgressBar(0, PROGRESS_MAX);
	progress.setStringPainted(true);

	JPanel panel = new JPanel();
	panel.setLayout(new GridLayout(0, 1));
	panel.add(new JLabel("Running..."));
	panel.add(progress);

	Object[] option = {buttonLabel};
	JOptionPane pane = new JOptionPane(panel,
					   JOptionPane.INFORMATION_MESSAGE,
					   JOptionPane.DEFAULT_OPTION,
					   null, option, option[0]);
	dialog = pane.createDialog(parent, "Auditor");
	dialog.setModal(false);
	dialog.addWindowListener(new WindowListener() {
	    public void windowActivated(final WindowEvent ev) {
            }
            public void windowClosed(final WindowEvent ev) {
		if (thread != null) {
		    thread.interrupt();
		}
            }
            public void windowClosing(final WindowEvent ev) {
            }
            public void windowDeactivated(final WindowEvent ev) {
            }
            public void windowDeiconified(final WindowEvent ev) {
            }
            public void windowIconified(final WindowEvent ev) {
            }
            public void windowOpened(final WindowEvent ev) {
            }
	});
	dialog.addComponentListener(new ComponentListener() {
            public void componentShown(final ComponentEvent ev) {
		thread = new Thread(task);
		thread.start();
            }
            public void componentMoved(final ComponentEvent ev) {
            }
            public void componentResized(final ComponentEvent ev) {
            }
            public void componentHidden(final ComponentEvent ev) {
		hide();
            }
	});

	task = new Runnable() {
	    public void run() {
		try {
		    Servant.this.run();
		} finally {
		    dialog.setVisible(false);
		}
	    }
	};

	stopped = false;
    }

    /**
       ɽƽ򳫻Ϥޤ

       λ뤫Ǥäߤؼ
       listenerrun()ƤӽФޤ

       @param listener ߡλΤ륪֥
    */
    public final void show(final Runnable listener) {
	this.listener = listener;
	stopped = false;
	parent.setEnabled(false);
	dialog.setVisible(true);
    }

    /**
       Ĥޤ
    */
    private void hide() {
	stopped = true;
	try {
	    thread.join();
	} catch (InterruptedException e) {
	}
	thread = null;
	dialog.setVisible(false);
	parent.setEnabled(true);
	listener.run();
    }

    /**
       Ľꤷޤ

       @param value Ľ
    */
    protected final void setProgress(final int value) {
	progress.setValue(value);
    }

    /**
       ĽγꡢԳΥ⡼ɤꤷޤ

       @param b Գ⡼ɤꤹȤtrue⡼ɤꤹ
       Ȥfalse
    */
    protected final void setIndeterminate(final boolean b) {
	progress.setIndeterminate(b);
    }

    /**
       ߤ򤵤Ƥ뤫ɤޤ

	@return ߤ򤵤Ƥ뤫ɤ
    */
    protected final boolean isStopped() {
	return stopped;
    }

    /**
       Хå饦ɽޤ

       ХȤΥ֥饹ϤΥ᥽åɤƤ
    */
    protected abstract void run();
}
