#define com_maroontress_libld_Trace_IMPORT
#define com_maroontress_libld_collector_Element_IMPORT

#include <sys/types.h>
#include <stdlib.h>
#include <string.h>
#include <com/maroontress/libld/Trace.h>
#include <com/maroontress/libld/collector/Element.h>

struct Element {
    size_t size;
    union Trace data[0];
};

struct Element *
Element_create(const void *data, size_t size)
{
    struct Element *e;

    if ((e = (struct Element *)malloc(sizeof(*e) + size)) == NULL)
        return NULL;
    bcopy(data, e->data, size);
    e->size = size;
    return e;
}

void
Element_free(struct Element *e)
{
    free(e);
}

int
Element_compare(struct Element *e1, struct Element *e2)
{
    unsigned int seq1 = e1->data[0].allocated.type;
    unsigned int seq2 = e2->data[0].allocated.type;

    return (int)(seq1 - seq2);
}

union Trace *
Element_getTrace(struct Element *e)
{
    return e->data;
}
