#define com_maroontress_testfunnel_funnel_vma_Place_IMPORT
#define com_maroontress_testfunnel_funnel_vma_Resolver_IMPORT
#define std_lang_String_IMPORT

#include <stdint.h>
#include <string.h>
#include <stdlib.h>
#include <dlfcn.h>
#include <com/maroontress/testfunnel/funnel/vma/Place.h>
#include <com/maroontress/testfunnel/funnel/vma/Resolver.h>
#include <std/lang/String.h>

struct Place {
    int valid;
    struct String *file;
    struct String *function;
    int line;
};

extern int main(void);

static struct String *
intern(const char *s)
{
    return (s == NULL) ? NULL : String_intern(s);
}

static void
initialize(/*@out@*/ struct Place *cache, intptr_t vma)
{
    Dl_info vmaInfo, mainInfo;
    const char *file, *function;
    int s, line;
    struct Resolver *r;

    if (dladdr((void *)main, &mainInfo) == 0
	|| dladdr((void *)vma, &vmaInfo) == 0
	|| (r = Resolver_create(vmaInfo.dli_fname)) == NULL) {
	return;
    }
    if (vmaInfo.dli_fbase != mainInfo.dli_fbase) {
	vma -= (intptr_t)vmaInfo.dli_fbase;
    }
    if ((s = Resolver_query(r, vma, &file, &function, &line)) == 0) {
	cache->valid = 1;
	cache->file = intern(file);
	cache->function = intern(function);
	cache->line = line;
    }
    Resolver_free(r);
}

struct Place *
Place_create(intptr_t vma)
{
    struct Place *place;

    if ((place = (struct Place *)malloc(sizeof(*place))) == NULL) {
	return NULL;
    }
    place->valid = 0;
    place->file = NULL;
    place->function = NULL;
    place->line = 0;
    /*
      VMAѴ˼Ԥ硢ԤȤΤΤ򥭥å¸
      ΤǡǤNULL֤ʤˡvalid0Τޤޤˤ
      Ƥ
    */
    initialize(place, vma);
    return place;
}

void
Place_free(struct Place *place)
{
    if (place == NULL)
	return;
    String_free(place->file);
    String_free(place->function);
    free(place);
}

char *
Place_getFile(struct Place *place)
{
    return (place->file == NULL) ? NULL : String_getData(place->file);
}

int
Place_getLine(struct Place *place)
{
    return place->line;
}

char *
Place_getFunction(struct Place *place)
{
    return (place->function == NULL) ? NULL : String_getData(place->function);
}

void
Place_staticInitialize(void)
{
    String_staticInitialize();
    Resolver_staticInitialize();
}
