#define com_maroontress_testfunnel_funnel_Auditor_IMPORT
#define com_maroontress_testfunnel_funnel_Display_IMPORT
#define com_maroontress_testfunnel_funnel_Event_IMPORT
#define com_maroontress_testfunnel_funnel_Test_IMPORT
#define com_maroontress_testfunnel_funnel_VMATranslator_IMPORT
#define com_maroontress_testfunnel_funnel_Workaround_IMPORT

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <err.h>
#include <com/maroontress/testfunnel/funnel/Auditor.h>
#include <com/maroontress/testfunnel/funnel/Display.h>
#include <com/maroontress/testfunnel/funnel/Event.h>
#include <com/maroontress/testfunnel/funnel/Test.h>
#include <com/maroontress/testfunnel/funnel/VMATranslator.h>
#include <com/maroontress/testfunnel/funnel/Workaround.h>

static void
usage(const char *progName)
{
    fprintf(stderr, "\
usage: %s [-s] [-m] [-t seconds] [-d hostname[:port]] solib [solib ...]\n",
	    progName);
    exit(1);
}

int
main(int ac, const char *const *av)
{
    struct Display *dpy;
    union Event *ev;
    const char *progName = av[0];
    const char *hostport = getenv("TF_DISPLAY");
    int standalone = 0, memoryLeak = 0, seconds = 5, opt;

    Workaround_processStarted();
    VMATranslator_staticInitialize();

    while ((opt = getopt(ac, (char *const *)av, "smt:d:")) != -1) {
	switch (opt) {
	case 's':
	    standalone = 1;
	    break;
	case 'm':
	    memoryLeak = 1;
	    break;
	case 't':
	    if ((seconds = atoi(optarg)) <= 0)
		errx(1, "invalid value: %s", optarg);
	    break;
	case 'd':
	    hostport = optarg;
	    break;
	default:
	    usage(progName);
	    /* NOTREAHCED */
	}
    }
    ac -= optind;
    av += optind;
    if (ac < 1) {
	usage(progName);
    }
    Auditor_setTimeout(seconds);
    Auditor_useTracer(memoryLeak);

    if (standalone) {
	Test_invokeAll(av);
	exit(0);
    }
    dpy = Display_open(hostport, av);
    Display_sendRecipe(dpy);
    while ((ev = Display_getEvent(dpy)) != NULL) {
	Event_dispatch(ev);
    }
    Display_close(dpy);
    exit(0);
    return 0;
}
